//
//  ScraperApp.m
//  ICrawler
//
//  Created by saleh on 1/29/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "ScraperApp.h"
#import "ICScraper.h"
#import "ICPipeline.h"
#import "ICExporter.h"



@implementation ScraperApp
@synthesize flag,scheduler,pipeline;

-(id)init{
	
	if(self=[super init]){
		
		scheduler=[[ICScheduler alloc] init];
	
	}
	return self;
}
-(void)dealloc{
	[pipeline release];
	[scheduler release];
	[super dealloc];
}

-(void) APsetURL:(NSString*) URL{

	[self setUrl:URL];
}
- (void) APsetFieldAndXPathQuery:(NSString*)field:(NSString*)query:(NSError**) error{

	[self setFieldAndXPathQuery:field :query :error];
}

- (NSMutableDictionary*) APcreateItem:(NSError**)error{

	
	NSMutableDictionary *theItem=[self CreateItem:error];
	[scheduler addElement:theItem :YES];
	 return theItem;
	
}
- (void) reset{

	[scheduler reset];
	NSLog(@"Scheduler has reset!");
}
- (id) ApStartScraping{

	ICPipeline *pipeline=[[ICPipeline alloc] init];
	NSMutableDictionary *next;
	
	while(flag){
		
		if ([[scheduler allElements] count]==0) {
			NSLog(@"No Item to Scrape!");
			return  nil;
		}
		
		// ----------- Start Scraping ------------
		NSError *err;
		next=[scheduler nextRequest:NO:&err];
		
		NSLog(@"NEXT Item IS -->> %@",next);
		
		if ( next != nil ) {
			
			id resault=[self scrape:next :NO];
			
			
			if(resault != nil){
				
				[pipeline addItem:resault];
				
				//[downloader download:[[resault allKeys]objectAtIndex:0]];
			} 
			
			
		}else {
			NSLog(@"%@",[err localizedDescription]);
			
			return ;
		} 
	}		
	
	[pipeline release];
}
- (void) start{
	
	[scheduler resetScheduler];
	self.flag=YES;
	[self ApStartScraping];
}
- (void) stop{
	
	self.flag=NO;
}

-(void) exportResult:(NSString*)URL :(NSString*)PATH :(NSString*)FILENAME{
	
	
	ICExporter *exporter=[[ICExporter alloc]init];
	
	[exporter exportItemsToXML:[pipeline itemsForURL:URL] :PATH :FILENAME];
	
	
	[exporter release];
	
}



@end
