//
//  ICPipeline.m
//  Link Extractor
//
//  Created by sa on 1/16/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "ICPipeline.h"


@implementation ICPipeline

@synthesize keys,keysQueue,queue;

- (id)init
{
    self = [super init];
    if (self) {
		keys = [NSMutableArray array];
        keysQueue = [NSMutableDictionary dictionary];
		queue = [NSMutableArray array];
    }
    
    return self;
}

//----------------------------------------------------
// Makes a new key and a empty Queue.
-(void) addWebsiteURL: (NSString *) URL {
	
	queue = [NSMutableArray array];
	[keys addObject:URL];
	[keysQueue setValue:queue forKey:URL];
}

// remove a key and its Queue.
-(void) delWebsiteURL: (NSString *) URL {
	
	[keys removeObject:URL];
	[keysQueue removeObjectForKey:URL];
}

-(void) addURL: (NSDictionary *) item{


	NSString * url=[[item allKeys] objectAtIndex:0];
	NSURL *theURL=[NSURL URLWithString:url];
	
	
	
	if([[keysQueue allKeys] containsObject:[theURL host]]){
		
		NSMutableArray *tempQueue=[keysQueue objectForKey:[theURL host]];
		
		[tempQueue addObject:item];
		[keysQueue setObject:tempQueue forKey:[theURL host]];
	}else {
		[self addWebsiteURL:[theURL host]];
		NSMutableArray *tempQueue=[keysQueue objectForKey:[theURL host]];
		[tempQueue addObject:item];
		[keysQueue setObject:tempQueue forKey:[theURL host]];
	}
	
	
}

-(void) addItem: (NSDictionary *) item{

	NSString * url=[[item allKeys] objectAtIndex:0];
	
	if([[keysQueue allKeys] containsObject:url]){
		
		NSMutableArray *tempQueue=[keysQueue objectForKey:url];
		[tempQueue addObject:item];
		[keysQueue setObject:tempQueue forKey:url];
	}else {
		[self addWebsiteURL:url];
		NSMutableArray *tempQueue=[keysQueue objectForKey:url];
		[tempQueue addObject:item];
		[keysQueue setObject:tempQueue forKey:url];
	}
	
	

}

-(NSMutableArray*)itemsForURL:(NSString*) URL{
	
	//NSURL *theURL=[NSURL URLWithString:URL];
	
	return [keysQueue objectForKey:URL];

}

-(NSMutableDictionary*)allItems{

	return keysQueue;
}
//----------------------------------------------------

- (NSInteger)size {
    return [keysQueue count];
}

- (BOOL)isEmpty {
    return [keysQueue count] == 0;
}

- (void)clear {
    [keysQueue removeAllObjects];
}

@end
