//
//  Scheduler.m
//  Untitled
//
//  Created by sa on 12/25/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ICScheduler.h"

@implementation ICScheduler


-(void) addElement: (id)element:(BOOL)allowDuplicate{
	
	
	switch (allowDuplicate) {
		case NO: if(![[self getQueue]containsObject:element]){
			        [self  push:element];
			NSLog(@"ADDED TO SCHEDULER -->> %@",element);
				 }
			break;
		case YES:[self  push:element];
			break;
	}
	
}
-(void) addElements: (NSArray *) elements:(BOOL)allowDuplicate{

	for(NSString *element in elements)
		if (element != nil) {
		[self addElement:element:allowDuplicate];
		}
}
-(void) addURLsFromPath: (NSString *)path{
	[self pushElements:(NSArray*)[self returnURLsFromPath:path]];
}

//----------------------------------------------------
-(NSMutableArray*) returnURLsFromPath: (NSString *)path{
	
	NSFileManager *filemgr;
	NSArray *fileNames;
	NSMutableArray *filePaths=[[[NSMutableArray alloc]init] autorelease];
	filemgr = [NSFileManager defaultManager];
	fileNames = [filemgr directoryContentsAtPath: path];
	
	if ([filemgr fileExistsAtPath:path]==NO) {
		
		NSLog(@"This path does not exist or its existence could not be determined!");
		
	}else {
		
		for(int i=0; i <[fileNames count]; i++)
		{
			[filePaths addObject:[path stringByAppendingFormat:[fileNames objectAtIndex:i]]];
			//NSLog (@"%@", [fileURLs objectAtIndex: i]);
		}
	}	
	
	return filePaths;
}
//----------------------------------------------------
-(NSMutableArray *)allElements{
	return [self getQueue];
}
//----------------------------------------------------
-(id) nextRequest:(BOOL)returnAndremove:(NSError**)error{
	
	NSError *theError;
	id var=[self pop:returnAndremove:&theError];
	
	if(var!=nil){
		
		return var;
		
	}else {
		
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:@"No element in the Scheduler to return!" forKey:NSLocalizedDescriptionKey];
		theError = [NSError errorWithDomain:@"myDomain" code:1 userInfo:errorDetail];
		*error=theError;
		return nil;
	}
}

-(void) resetScheduler{

	[self reset];
}

-(BOOL)isEmpty{

	return [self isEmpty];
}

@end

//-------------------------------------------------------
//-------------------------------------------------------
//-------------------------------------------------------

@implementation ICCrawlerScheduler

-(void) addWebsiteURL: (NSString *) URL{

	[self addKey:URL];
}

-(void) addURL: (NSString *) URL{
	
	NSURL *url=[NSURL URLWithString:URL];
	[self push:[url host] :URL];
}
// should be fixed !!!
-(void) addURLs: (NSArray *) URLs{
	
	for(NSString *link in URLs){
		[self addURL:link];
	}
}

//----------------------------------------------------
-(NSMutableArray*) returnURLsFromPath: (NSString *)path{
	
	NSFileManager *filemgr;
	NSArray *fileNames;
	NSMutableArray *filePaths=[[[NSMutableArray alloc]init] autorelease];
	filemgr = [NSFileManager defaultManager];
	fileNames = [filemgr directoryContentsAtPath: path];
	
	if ([filemgr fileExistsAtPath:path]==NO) {
		
		NSLog(@"This path does not exist or its existence could not be determined!");
		
	}else {
		
		for(int i=0; i <[fileNames count]; i++)
		{
			[filePaths addObject:[path stringByAppendingFormat:[fileNames objectAtIndex:i]]];
			//NSLog (@"%@", [fileURLs objectAtIndex: i]);
		}
	}	
	
	return filePaths;
}

-(NSMutableArray *)currentQueue:(NSString *)WebsiteURL{

	return [self getQueue:WebsiteURL];

}

//----------------------------------------------------
-(NSString*) currentWebsite{
	
	return [[self getKeys] objectAtIndex:0];
}

-(id) nextRequest:(NSError**)error{
	
	if([self pop]!=nil){
	
		return [self pop];
		
	}else {
		
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:@"No element in the Queue to return!" forKey:NSLocalizedDescriptionKey];
		*error = [NSError errorWithDomain:@"myDomain" code:1 userInfo:errorDetail];
		return nil;
	}
	
}

@end
