
#import "ICScraper.h"
#import "TFHpple.h"
#import "TFHppleElement.h"

@implementation ICScraper
@synthesize fields,item,url;

//------------------------------------------------------------

-(id)init{
	if(self=[super init]){
		item=[NSMutableDictionary dictionary];
		fields=[NSMutableDictionary dictionary];
		
	}
	return self;
}

-(void)dealloc{
	
	[super dealloc];
}

-(void)setUrl:(NSString*)itemsURL{
	
	url=itemsURL;
}

//------------------------------------------------------------
-(id)setFieldAndXPathQuery:(NSString*)field:(NSString*)query:(NSError**)error{
	
	BOOL duplicateField=[[fields allKeys] containsObject:field];
	if (!duplicateField) {
		[fields setObject:query forKey:field];
	}else {
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:[NSString stringWithFormat:@"'%@' field is Duplicate! Choose different field.",field] forKey:NSLocalizedDescriptionKey];
		*error = [NSError errorWithDomain:@"myDomain" code:1 userInfo:errorDetail];
		return nil;
	}
	
}

//------------------------------------------------------------

-(NSMutableDictionary*)CreateItem:(NSError**)error{
	
	if ([item count]!=0){
		[item removeAllObjects];
	}
	
	if (url==NULL) {
		
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:@"Enter URL!" forKey:NSLocalizedDescriptionKey];
		*error = [NSError errorWithDomain:@"myDomain" code:1 userInfo:errorDetail];
		return nil;
	}
	
	if ([fields count]==0) {
		
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:@"Fields are empty!" forKey:NSLocalizedDescriptionKey];
		*error = [NSError errorWithDomain:@"myDomain" code:2 userInfo:errorDetail];
		return nil;
	}
	
	[item setObject:fields forKey:url];
	
	return item;
}
//------------------------------------------------------------

-(NSString*)getValueForField:(NSString*)field{
	return [fields objectForKey:field];
}

-(NSArray*)allfields{
	
	return [fields allKeys];
}

-(NSArray*)allvalues{
	
	return [fields allValues];
}

-(void)removeField:(NSString*)field{
	
	[fields removeObjectForKey:field];
	
}
-(void)removeAllFields{
	
	[fields removeAllObjects];
}

//------------------------------------------------------------

-(NSDictionary*)scrape:(NSMutableDictionary*)theItem: (BOOL)addDateTime{
	
	NSMutableDictionary *ripeItem=[NSMutableDictionary dictionary];
	NSData *data;
	TFHpple *doc;
	NSMutableDictionary *rawItem=[theItem objectForKey:[[theItem allKeys] objectAtIndex:0]];
	NSString *theURL=[[theItem allKeys] objectAtIndex:0];
	
	// check if it is a URL or Path!
	NSFileManager *file=[NSFileManager defaultManager];
	if (![file fileExistsAtPath:theURL]) {
		data=[NSData dataWithContentsOfURL:[NSURL URLWithString:theURL]];
	}else {
		data=[NSData dataWithContentsOfFile:theURL];
	}
	
	// check if it is a XML file or HTML!
	NSString *content = [[NSString alloc]  initWithBytes:[data bytes]
												  length:5 encoding: NSUTF8StringEncoding];
	if ([content isEqualToString:@"<?xml"]) {
		doc=[[TFHpple alloc] initWithXMLData:data];
	}else {
		doc=[[TFHpple alloc] initWithHTMLData:data];
	}
	NSString *field;
	
	
	for(field in rawItem){
		
		@try {
			NSArray *elements=[doc searchWithXPathQuery:[rawItem objectForKey:field]];
			TFHppleElement *e=[elements objectAtIndex:0];
			[ripeItem setObject:[e content] forKey:field];
			
		}@catch (NSException * ee) {
			NSLog(@"%@",ee);
			NSLog(@"Scraper was not able to scrape '%@' field!",field);
		}
		
	}
	
	if (addDateTime) {
		NSDate *dateTime=[NSDate date];
		[ripeItem setObject:dateTime forKey:@"date"];
	}
	
	NSLog(@"RipeItem is --> %@",ripeItem);
	[doc release];	
	return (NSDictionary*)ripeItem;	
	
}



@end


